<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services\RelTipoSangriaService;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;

class RelTipoSangria  extends  CrudWithParameterBag{ 
    
    const dataSourceTipoSangria = 'select_tipoSangria';
    
    protected $parameterBagColumnsTipoSangria = array('NRORG'),
              $utilService,
              $DayPartService;
              
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager, RelTipoSangriaService $RelTipoSangriaService) {
        $this->crudService               = $crudService;
        $this->parameterBag              = $parameterBag;
        $this->entityManager             = $entityManager;
        $this->utilService               = $utilService;
        $this->dataSourceManager         = $dataSourceManager;
        $this->reportService             = $RelTipoSangriaService;
    }
    
    
     public function findReport(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])){
        $result = $this->reportService->fetchReport($conditions);
        $response->addDataSet(new DataSet("vnd01200_relTipoSangria", $result));
        }
        return $result;
    }
    
     public function findTipoSangria(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceTipoSangria;
        $this->parameterBagColumns = $this->parameterBagColumnsTipoSangria;
        
        parent::find($request, $response);
    }
    
}
