<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelFechamentoCaixaPendente {

	public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($CDOPERADOR, $NRORG, $CDFILIAL, $DTINI, $DTFIN,$TDTMOVTURCAIX, $CDCAIXA) {
    $params = array(
      ":CDOPERADOR" => $CDOPERADOR,
      ":CDFILIAL" => $CDFILIAL,
      ":TCDFILIAL" => $CDFILIAL,
      ":CDCAIXA" => $CDCAIXA,
     	":TCDCAIXA" => $CDCAIXA,
      ":DTINI" => $DTINI,
      ":DTFIN" => $DTFIN,
      ":TDTMOVTURCAIX" => $TDTMOVTURCAIX,
     	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_FECHAMENTO_CAIXA_PENDENTE, $params);
  }
    
  const GET_FECHAMENTO_CAIXA_PENDENTE = "
    SELECT T.CDCAIXA||' - '||C.NMCAIXA AS LABELCAIXA,
           T.CDFILIAL||' - '||FI.NMFILIAL AS LABELFILIAL,
           T.CDFILIAL, FI.NMFILIAL, T.CDCAIXA, C.NMCAIXA, 
           TO_DATE(T.DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS') AS DTABERCAIX, 
           T.CDOPERABER, O.NMOPERADOR, T.DTMOVTURCAIX, T.NRORG
      FROM TURCAIXA T 
      JOIN FILIOPER F 
        ON T.CDFILIAL = F.CDFILIAL 
       AND T.NRORG = F.NRORG
      JOIN FILIAL FI
        ON T.CDFILIAL = FI.CDFILIAL
       AND T.NRORG = FI.NRORG
      JOIN CAIXA C
        ON T.CDFILIAL = C.CDFILIAL
       AND T.CDCAIXA = C.CDCAIXA
       AND T.NRORG = C.NRORG
      JOIN OPERADOR O
        ON T.CDOPERABER = O.CDOPERADOR
       AND T.NRORG = O.NRORG 
     WHERE T.DTFECHCAIX IS NULL 
       AND F.CDOPERADOR = :CDOPERADOR
       AND T.NRORG = :NRORG
       AND (T.DTMOVTURCAIX BETWEEN NVL(:DTINI, SYSDATE-30) AND NVL(:DTFIN, SYSDATE))
       AND ((INSTR(:CDCAIXA, T.CDFILIAL ||T.CDCAIXA) >0 ) OR ( :CDCAIXA = 'T' ) )
       AND (INSTR(:CDFILIAL, T.CDFILIAL) > 0 OR (:TCDFILIAL  = 'T'))
     ORDER BY CDFILIAL, CDCAIXA, DTABERCAIX
  ";
}